@echo off
setlocal

REM ##### ݒ #####
set OPENSTANDIA_INSTALLER_VER=3.0.0.0beta
set STACK_XML=stack-%OPENSTANDIA_INSTALLER_VER%.xml
set LICENSE_FILE=license.txt
set ANT_DIR=apache-ant-1.7.0
set SCRIPTS_DIR=scripts
set APACHE_NO=1
set JBOSS_NO=3
set MOD_JK_NO=5
set MYSQL_NO=7
set PET_STORE_NO=9
set APACHE_TOMCAT_NO=11


REM #####  #####
set CURRENT_DIR=%~dp0
if NOT "%CURRENT_DIR:~-1%" == "\" (
	set CURRENT_DIR=%CURRENT_DIR%\
)
set ANT_HOME=%CURRENT_DIR%lib\%ANT_DIR%
set PATH=%ANT_HOME%\bin;%CURRENT_DIR%bin;%PATH%
set SCRIPTS_DIR=%CURRENT_DIR%%SCRIPTS_DIR%
if NOT "%SCRIPTS_DIR:~-1%" == "\" (
	set SCRIPTS_DIR=%SCRIPTS_DIR%\
)


REM ##### s[U[`FbN #####
call %CURRENT_DIR%bin\CheckAuthority.bat
if errorlevel 1 (
	echo s[U[AdministratorsȂߏ𑱍sł܂B
	goto end
)


REM ##### javaCXg[`FbN #####
call %CURRENT_DIR%bin\CheckInstalledJava.bat
if errorlevel 1 (
	echo javaCXg[ĂȂߏ𑱍sł܂B
	goto end
)


REM ##### ʕ\ #####
cls
echo OpenStandia Ver.%OPENSTANDIA_INSTALLER_VER%
echo eOSS̃CXg[AACXg[AAbvf[g܂B
echo.
echo IĂB
echo 1 : CXg[
echo 2 : ACXg[
echo 3 : Abvf[g
set MODE_NO=1
set /p MODE_NO=
if "%MODE_NO%" == "1" (
	set MODE=install
	set MODE_STR=CXg[
)
if "%MODE_NO%" == "2" (
	set MODE=uninstall
	set MODE_STR=ACXg[
)
if "%MODE_NO%" == "3" (
	set MODE=update
	set MODE_STR=Abvf[g
)


REM ##### CZX\ ######
if "%MODE%" == "install" (
	cls
	more "%LICENSE_FILE%"
	set RESULT=n
	set /p RESULT=ӂ܂H^(y/n^) [n]
) else (
	goto next
)
if "%RESULT%" == "y" (
	goto next
)
goto end
:next


REM ##### CXg[S̑O #####
echo.
call ant -Dmode=%MODE% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%install-before.xml"
if errorlevel 1 goto error


REM ##### ₢킹 #####
cls
REM Apache
set INSTALL_APACHE=y
set /p INSTALL_APACHE=Apache%MODE_STR%܂H(y/n) [y]
set INSTALL_APACHE_CONF=0
if "%MODE%" == "install" (
	if "%INSTALL_APACHE%" == "y" (
		echo Apachep̐ݒt@C^(httpd.conf^)IĂB
		echo 1 : ftHg
		echo 2 : OpenStandiaݒ
		set /p INSTALL_APACHE_CONF=
	)
)

REM JBoss
set INSTALL_JBOSS=y
set /p INSTALL_JBOSS=JBoss%MODE_STR%܂H(y/n) [y]

REM mod_jk
set INSTALL_MOD_JK=y
set /p INSTALL_MOD_JK=mod_jk%MODE_STR%܂H(y/n) [y]

REM MySQL
set INSTALL_MY_SQL=y
set /p INSTALL_MY_SQL=MySQL%MODE_STR%܂H(y/n) [y]

REM petStore
set INSTALL_PET_STORE=y
set /p INSTALL_PET_STORE=TvAvP[V%MODE_STR%܂H(y/n) [y]

REM apache-tomcat
set INSTALL_APACHE_TOMCAT=y
set /p INSTALL_APACHE_TOMCAT=Apache-TomcatAg%MODE_STR%܂H(y/n) [y]


REM ##### _E[hs #####
echo.
echo _E[hJn܂...
if "%INSTALL_APACHE%" == "y" (
	call ant -Dno=%APACHE_NO% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%download.xml"
	if errorlevel 1 goto error
)
if "%INSTALL_JBOSS%" == "y" (
	call ant -Dno=%JBOSS_NO% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%download.xml"
	if errorlevel 1 goto error
)
if "%INSTALL_MOD_JK%" == "y" (
	call ant -Dno=%MOD_JK_NO% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%download.xml"
	if errorlevel 1 goto error
)
if "%INSTALL_MY_SQL%" == "y" (
	call ant -Dno=%MYSQL_NO% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%download.xml"
	if errorlevel 1 goto error
)
if "%INSTALL_PET_STORE%" == "y" (
	call ant -Dno=%PET_STORE_NO% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%download.xml"
	if errorlevel 1 goto error
)
if "%INSTALL_APACHE_TOMCAT%" == "y" (
	call ant -Dno=%APACHE_TOMCAT_NO% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%download.xml"
	if errorlevel 1 goto error
)


REM ##### CXg[s #####
set INSTALLED_NO=
echo.
echo %MODE_STR%Jn܂...
if "%INSTALL_APACHE%" == "y" (
	call ant -Dno=%APACHE_NO% -Dsub=%INSTALL_APACHE_CONF% -Dmode=%MODE% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%install.xml"
	if errorlevel 1 goto error
	set INSTALLED_NO=%INSTALLED_NO%,%APACHE_NO%
)
if "%INSTALL_JBOSS%" == "y" (
	call ant -Dno=%JBOSS_NO% -Dmode=%MODE% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%install.xml"
	if errorlevel 1 goto error
	set INSTALLED_NO=%INSTALLED_NO%,%JBOSS_NO%
)
if "%INSTALL_MOD_JK%" == "y" (
	call ant -Dno=%MOD_JK_NO% -Dmode=%MODE% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%install.xml"
	if errorlevel 1 goto error
	set INSTALLED_NO=%INSTALLED_NO%,%MOD_JK_NO%
)
if "%INSTALL_MY_SQL%" == "y" (
	call ant -Dno=%MYSQL_NO% -Dmode=%MODE% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%install.xml"
	if errorlevel 1 goto error
	set INSTALLED_NO=%INSTALLED_NO%,%MYSQL_NO%
)
if "%INSTALL_PET_STORE%" == "y" (
	call ant -Dno=%PET_STORE_NO% -Dmode=%MODE% -DinstalledNo="%INSTALLED_NO%" -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%install.xml"
	if errorlevel 1 goto error
	set INSTALLED_NO=%INSTALLED_NO%,%PET_STOREK_NO%
)
if "%INSTALL_APACHE_TOMCAT%" == "y" (
	call ant -Dno=%APACHE_TOMCAT_NO% -Dmode=%MODE% -DinstalledNo="%INSTALLED_NO%" -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%install.xml"
	if errorlevel 1 goto error
)


REM ##### CXg[Š㏈ #####
echo.
call ant -Dmode=%MODE% -DstackXml=%STACK_XML% -f "%SCRIPTS_DIR%install-after.xml"
if errorlevel 1 goto error

goto end
REM ##### ُI #####
:error
echo %MODE_STR%̓rňُ킪܂...


REM ##### I #####
:end
echo %MODE_STR%I܂...

endlocal
